#version 430 core
/*
* Creating primitive object from input-points
* Eva | Sources: https://github.com/Crisspl/GPU-particle-system/blob/master/particles/main.cpp & GPU Particle Systems Slides from Repetitorium 2018
*/

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

in vec3 vs_color[];
out vec3 fs_color;
out vec2 fs_txCoords;

layout(location = 1) uniform mat4 projection;

vec2 texCoord[4] = {
	vec2(0.f, 0.f),
	vec2(1.f, 0.f),
	vec2(0.f, 1.f),
	vec2(1.f, 1.f)  
};

vec2 texPos[4] = {
	vec2(-0.5f, -0.8f),
	vec2( 0.8f, -0.8f),
	vec2(-0.5f,  0.8f),
	vec2( 0.8f,  0.8f)
};

float size = 0.1;

void main() {
	fs_color = vs_color[0];
	for (int i = 0; i < 4; ++i) {
		fs_txCoords = texCoord[i];
		vec4 pos = gl_in[0].gl_Position;
		pos.xy += size * (texCoord[i] - texPos[i]);
		gl_Position = projection * pos;
		EmitVertex();
	}

	EndPrimitive();
}