#version 430 core
/*
* Vertex-Shader including TTL from fire_particle.comp & interpolating fadeColor with color
* Eva | Sources: https://github.com/Crisspl/GPU-particle-system/blob/master/particles/main.cpp & GPU Particle Systems Slides from Repetitorium 2018
*/

layout(location = 0) in vec4 position;
layout(location = 0) uniform mat4 view;
out vec3 vs_color;

void main() {
	float TTL = position.w;
	vec3 color = vec3(1.0f, 0.5f, 0.1f);
	vec3 fadeColor = vec3(0.8f, 0.4f, 0.1f);

	vs_color = mix(fadeColor, color, TTL);
	gl_Position = view * vec4(position.xyz, 1.f);
}